/*
 xGL:Shader.h
 Created by mantis on 4/07/05.
 Copyright 2005 xonko interactive. All rights reserved.
*/

#import <Cocoa/Cocoa.h>
#import "vectorLib.h"
#import "XGLTextureLayer.h"

@interface XGLShader : NSObject {
	
	GLuint shaderID;
	
	NSColor *diffuse;
	NSColor *ambient;
	NSColor *specular;
	NSColor *emissive;
	float specularity;

	NSMutableArray *textureLayers;
	NSString *facing;
	NSString *colorMaterialMode;
	NSString *name;
	
	BOOL built;
	bool currentShader;
	
	GLenum glfacing;
	GLenum glcolorMaterialMode;
	GLfloat sDiffuse[4];
	GLfloat sAmbient[4];
	GLfloat sEmissive[4];
	GLfloat sSpecular[4];
	GLfloat sSpecularity[1];
	
	
}


+(NSArray *)facingModes;
+(NSArray *)colorMaterialModes;

//-(id)init;
-(void)loadShader;
-(void)build;

-(void)setNotCurrentShader;

-(id)textureLayers;
-(void)setTextureLayers:(id)newTextures;

-(void)addTextureLayer:(id)aTexture;

-(NSColor *)diffuse;
-(void)setDiffuse:(NSColor *)newColor;

-(NSColor *)ambient;
-(void)setAmbient:(NSColor *)newColor;

-(NSColor *)emissive;
-(void)setEmissive:(NSColor *)newColor;

-(NSColor *)specular;
-(void)setSpecular:(NSColor *)newColor;

-(float)specularity;
-(void)setSpecularity:(float)level;

-(NSString *)name;
-(void)setName:(NSString *)aName;

- (NSString *)facing;
- (void)setFacing:(NSString *)value;

- (NSString *)colorMaterialMode;
- (void)setColorMaterialMode:(NSString *)value;

@end
